package eu.mhsl.craftattack.spawn.appliances.debug.command;

import eu.mhsl.craftattack.spawn.Main;
import eu.mhsl.craftattack.spawn.appliance.ApplianceCommand;
import eu.mhsl.craftattack.spawn.appliances.debug.Debug;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.ComponentBuilder;
import net.kyori.adventure.text.TextComponent;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.jetbrains.annotations.NotNull;

import java.util.stream.Collectors;

public class AppliancesCommand extends ApplianceCommand<Debug> {
    public AppliancesCommand() {
        super("appliances");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        ComponentBuilder<TextComponent, TextComponent.Builder> componentBuilder = Component.text()
                .append(Component.text(Main.instance().getAppliances().size()))
                .append(Component.text(" appliances loaded:"))
                .appendNewline()
                .append(Component.text(Main.instance().getAppliances().stream().map(appliance -> appliance.getClass().getSimpleName()).collect(Collectors.joining(", "))));

        sender.sendMessage(componentBuilder.build());
    }
}
