package eu.mhsl.craftattack.spawn.appliances.playerlimit;

import eu.mhsl.craftattack.spawn.appliance.Appliance;
import eu.mhsl.craftattack.spawn.appliance.ApplianceCommand;
import eu.mhsl.craftattack.spawn.config.Configuration;
import org.bukkit.Bukkit;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class PlayerLimit extends Appliance {
    private static final String playerLimitKey = "maxPlayers";
    private int limit;
    public PlayerLimit() {
        super("playerLimit");
        this.limit = localConfig().getInt(playerLimitKey);
        Bukkit.setMaxPlayers(Integer.MAX_VALUE);
    }

    public void setPlayerLimit(int limit) {
        this.limit = limit;
        localConfig().set(playerLimitKey, limit);
        Configuration.saveChanges();
    }

    public int getLimit() {
        return limit;
    }

    @Override
    protected @NotNull List<Listener> eventHandlers() {
        return List.of(
                new PlayerLimiterListener()
        );
    }

    @Override
    protected @NotNull List<ApplianceCommand<?>> commands() {
        return List.of(
                new SetPlayerLimitCommand()
        );
    }
}
